/****************************************************************************\
		                      MicroAVS SDK API
\****************************************************************************/
#ifndef _MAAPI_H_
#define _MAAPI_H_

#ifdef WIN64
typedef __int64 xp_long;
#else
typedef int xp_long;
#endif

#include "MAdefs.h"

	#ifdef __cplusplus
	extern "C" {
	#endif

	#pragma message( "including MAapi.h" )

	// ̔z̃TCY擾
	long MAget_ndim(int* pNDim);
	// ẽTCY̎擾s
	long MAget_dims(xp_long** ppDims, xp_long* pSize);
	// Ԃ̎iW̔z񐔁j̎擾s
	long MAget_nspace(int* pNSpace);
	// z̃TCY擾
	long MAget_npoints(xp_long* pNPoints);
	// Uniform^ARectilinear^̏ꍇ̍W̎擾s
	long MAget_points(float** ppPoints, xp_long* pSize);
	// Uniform^ARectilinear^̏ꍇ̍W̐ݒs
	long MAset_points(float* pPoints, xp_long Size);
	// Irregular^̏ꍇ̍W̎擾s
	long MAget_coordinates(float** ppCoordinates, xp_long* pSize);
	// Irregular^̏ꍇ̍W̐ݒs
	long MAset_coordinates(float* pCoordinates, xp_long Size);
	// f[^̃^Cvi^j̎擾s
	long MAget_data_type(int Component, int* pDataType);
	// m[h̎擾s
	long MAget_nnodes(xp_long* pNNodes0);
	// R|[lg̐̎擾s
	long MAget_node_ncomp(int* pComponents);
	// R|[lg̃x̎擾s
	long MAget_node_data_label(int Component, char* pLabel);
    // R|[lg̃xNg̐擾
	long MAget_node_data_veclen(int Component, int* pVeclen);
    // R|[lg̃xNg̐ݒ肷
	long MAget_node_data(int Component, char** ppNodeData, xp_long* pSize, int* pDataType);
	// m[hf[^̐ݒs
	long MAset_node_data(int Component, char* pNodeData, xp_long Size, int DataType);
	// m[hf[^̒ǉsi num Ŏwj
	long MAadd_node_data(int num, char* pNodeData, xp_long Size, int DataType, char DataLabel[][MAX_LABEL_SIZE]);

	// ZZbg̐擾
	long MAget_celldata_ncomp(int* pCellComponents);
	// xNg̐擾
	long MAget_cell_data_veclen(int CellComponent, int *pVeclen);
	// Zf[^̎擾s
	long MAget_cell_data(int CellComponent, char** ppCellData, xp_long* pSize, int* pDataType);
	// Zf[^̐ݒs
	long MAset_cell_data(int CellComponent, char* pCellData, xp_long Size, int DataType);
	// Zf[^̒ǉs
	long MAadd_cell_data(char* pCellData, xp_long Size, int DataType, char* DataLabel);

	//  ubN蓖Ă܂B
	void* MAalloc(int type, xp_long size);
	//  ubN̊蓖Ă܂B
	void MAfree(void* memblock);
	// ^Cvʂ̃oCgԂ܂B
	int MAtype_size(int type);

	// Utility
	long MAcurl(char *pUData, char *pVData, char *pWData, xp_long Size, int DataType, char *pUResult, char *pVResult, char *pWResult);
	long MAmagnitude(char *pUData, char *pVData, char *pWData, xp_long Size, int DataType, char *pResult);
	long MAdivergence(char *pUData, char *pVData, char *pWData, xp_long Size, int DataType, char *pResult);
	long MAgradient(char *pData, xp_long Size, int DataType, char *pUResult, char *pVResult, char *pWResult);

	#ifdef __cplusplus
		}
	#endif

#endif //_MAAPI_H_
